author | Michael Krelin <hacker@klever.net> | 2016-01-06 23:46:31 (UTC) |
---|---|---|
committer | Michael Krelin <hacker@klever.net> | 2016-01-06 23:46:31 (UTC) |
commit | 4cb92354224641376d311adc7589ebb4bdc5639d (patch) (side-by-side diff) | |
tree | f6d856a472a52f1af9a34803f72b305f955524e5 /delta.jscad | |
parent | 8cd03b0c3f807d552a6721886a3af0af8b592a1c (diff) | |
download | redelta-4cb92354224641376d311adc7589ebb4bdc5639d.zip redelta-4cb92354224641376d311adc7589ebb4bdc5639d.tar.gz redelta-4cb92354224641376d311adc7589ebb4bdc5639d.tar.bz2 |
duet()
-rw-r--r-- | delta.jscad | 27 |
1 files changed, 27 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad index 043f6f8..b3bb3d3 100644 --- a/delta.jscad +++ b/delta.jscad @@ -304,331 +304,358 @@ var EFFECTOR = { }).subtract(CSG.cylinder({ start: [0,0,e.h+e.hinge.e-1], end: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h+1], radius: CONFIG.hotend.groove.d/2 +PRINT.fit_tolerance })) ).union( /* upper hotend holder */ CSG.cylinder({ start: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h], end: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h+CONFIG.hotend.ungroove.above], radius: hhr }).subtract(CSG.cylinder({ start: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h-1], end: [0,0,e.h+e.hinge.e+CONFIG.hotend.groove.h+CONFIG.hotend.ungroove.above+1], radius: CONFIG.hotend.ungroove.d/2 +PRINT.fit_tolerance })) ).union( /* connect mount with hinge */ CSG.cube({ corner1: [-hinges_apart+PRINT.slide_tolerance,CONFIG.hotend.ungroove.d/2+PRINT.fit_tolerance,e.h+e.hinge.e], corner2: [hinges_apart-PRINT.slide_tolerance,e.o,e.h+e.hinge.h+e.hinge.d/2+e.hinge.margin] }) ).subtract( /* hinge screwhole */ CSG.cylinder({ start: [-hinges_apart-1,e.o,e.h+e.hinge.h], end: [hinges_apart+1,e.o,e.h+e.hinge.h], radius: e.hinge.d/2 }) ).union( /* hold clamp together */ [-1,1].map(function(s) { return CSG.roundedCube({ corner1: [s*(-hhr-e.clamp.margin*2-e.clamp.d),-e.clamp.shell,e.h+e.hinge.e], corner2: [s*(-CONFIG.hotend.ungroove.d/2-PRINT.fit_tolerance),+e.clamp.shell,e.h+e.hinge.e+hhh], roundradius: 1.5 }); }) ).subtract( /* screws for holding clamp */ [-1,1].map(function(s) { var nuthole = nut(CONFIG.nut); var x = s*(-hhr-e.clamp.margin-e.clamp.d/2); return CSG.cylinder({ start: [x,-e.clamp.shell-1,e.h+e.hinge.e+hhh/2], end: [x,e.clamp.shell+1,e.h+e.hinge.e+hhh/2], radius: e.clamp.d/2 }).union(nuthole.connectTo( nuthole.properties.axis_connector, new CSG.Connector([x,e.clamp.shell,e.h+e.hinge.e+hhh/2],[0,-1,0],[0,0,1]), false, 0 )).union(CSG.cylinder({ start: [x,-e.clamp.shell-1,e.h+e.hinge.e+hhh/2], end: [x,0,e.h+e.hinge.e+hhh/2], radius: e.clamp.d/2+PRINT.slide_tolerance })); }) ); var ms = o.microswitch; var msedge = o.effector.properties.rcorner; var msh = 9.5; // microswitch holes apart var mshh = Math.abs(ms.properties.switch_connector.point.z-ms.properties.screw_connector[0].point.z); // microswitch holes height rv = rv.union(CSG.cube({ // connect clamp with microswitch corner1: [-ms.properties.microswitch.size.x/2,-msedge+.1,e.h+e.hinge.e], corner2: [+ms.properties.microswitch.size.x/2,-CONFIG.hotend.ungroove.d/2-PRINT.fit_tolerance,e.h+e.hinge.e+hhh] })).union([-msh/2,msh/2].map(function(x) { // shell for microswitch screws return CSG.roundedCylinder({ start: [x,-CONFIG.hotend.ungroove.d/2-PRINT.fit_tolerance-(e.mswitch.screw.d/2+e.mswitch.screw.s),e.h+e.hinge.e+mshh], end: [x,-msedge+ms.properties.microswitch.size.y,e.h+e.hinge.e+mshh], radius: e.mswitch.screw.d/2+e.mswitch.screw.s }); })).subtract(CSG.cube({ // cut off excess if any corner1:[-hhr,-msedge+ms.properties.microswitch.size.y,e.h+e.hinge.e-1], corner2:[hhr,-msedge-1,e.h+e.hinge.e+hhh+e.mswitch.screw.d+e.mswitch.screw.s+1] })).subtract([-msh/2,msh/2].map(function(x) { return CSG.roundedCylinder({ // screwholes start: [x,-CONFIG.hotend.ungroove.d/2-PRINT.fit_tolerance-(e.mswitch.screw.d/2+e.mswitch.screw.s),e.h+e.hinge.e+mshh], end: [x,-msedge+ms.properties.microswitch.size.y,e.h+e.hinge.e+mshh], radius: e.mswitch.screw.d/2 })})).subtract(CSG.cylinder({ // pulldown screw start:[0,-msedge+ms.properties.microswitch.size.y+3/2/*XXX:config*/+PRINT.extrusion_width,e.h+e.hinge.e-1], end:[0,-msedge+ms.properties.microswitch.size.y+3/2/*XXX:config*/+PRINT.extrusion_width,e.h+e.hinge.e+hhh+1], radius: 3/2/*XXX:config*/ })); rv.properties.microswitch_screw_connector = new CSG.Properties(); [-msh/2,msh/2].forEach(function(x,i) { rv.properties.microswitch_screw_connector[i] = new CSG.Connector( [x,-msedge,e.h+e.hinge.e+mshh], [0,1,0], [0,0,-1] ); }); return rv.setColor([0.3,0.8,0.3,0.9]); }, split_hinged: function effector_split_hinged(hinged) { var e = CONFIG.effector; var b = hinged.getBounds(); var ymax = Math.max(Math.abs(b[0].y),Math.abs(b[1].y)); var zmax = Math.max(b[0].z,b[1].z); return [-1,1].map(function(s) { return hinged.intersect(CSG.cube({ corner1: [Math.min(b[0].x,b[1].x)-1,s*e.clamp.split/2,-zmax-1], corner2: [Math.max(b[0].x,b[1].x)+1,s*(ymax+1),zmax+1] })); }); }, fanholder: function effector_fanholder() { var fh = CONFIG.effector.fanholder; var od = fh.screw.d+2*fh.screw.m; return linear_extrude({height:fh.w},hull( CAG.circle({center:[0,-this.rmount],radius:od/2}), CAG.circle({center:[0,-fh.r+od/2+fh.w/2],radius:fh.w/2}) )).translate([0,0,-fh.w]).union( linear_extrude({height:fh.w},hull( CAG.circle({center:[fh.w/2,-this.rmount-od/2-fh.w/2],radius:fh.w/2}), CAG.circle({center:[od/2,-fh.r],radius:od/2}) )).rotateY(90).translate([-fh.w/2,0,0]) ).subtract( CSG.cylinder({ start: [-fh.w,-fh.r,-od/2], end: [fh.w,-fh.r,-od/2], radius: fh.screw.d/2 })).subtract( CSG.cylinder({ start: [0,-this.rmount,1], end: [0,-this.rmount,-fh.w-1], radius: fh.screw.d/2 })).setColor([0.3,0.8,0.3,0.9]).rotateZ(-120); } }; function columns() { var rv = [0,1,2].map(function(x) { return union(vector_char(0,0,String.fromCharCode('A'.charCodeAt(0)+x)).segments.map(function(x) { return rectangular_extrude(x,{w:2,h:1}); })).center().rotateX(90).translate([0,50,0]).rotateZ(x*120+120); }); return union(rv); } function microswitch() { var screw_connector = new CSG.Properties(); var rv = CSG.cube({ center:[0,0,2.5],radius: [19.8/2,6/2,10/2] }).union( CSG.cube({ center: [2.5,0.5,6], radius: [2/2,3.5/2,5/2] }) ).union( [-8,-1,8].map(function(x) { return CSG.cube({ center:[x,0,0], radius: [0.6/2,3.2/2,13/2] }) }) ).subtract( [-9.5/2,9.5/2].map(function(x,i) { screw_connector[i] = new CSG.Connector([x,6/2,0],[0,-1,0],[0,0,1]); return CSG.cylinder({ start: [x,-4,0], end: [x,4,0], radius: 2/2 }) }) ); rv.properties.switch_connector = new CSG.Connector([2.5,0.5,6+5/2],[0,0,1],[0,-1,0]); rv.properties.screw_connector = screw_connector; rv.properties.microswitch = new CSG.Properties(); rv.properties.microswitch.size = new CSG.Vector3D( 19.8,6,10 ); return rv; } var FOURWINDS = [0,90,180,270]; var E2020 = { outer: 20, thickness: 1.8, roundius: 1, centerhole: 5, slot_width: 6, T: { width: 10, thickness: 1.5, depth: 6.5 }, extrusion: function(o) { if(!o) o = {}; var e = o.extrusion || this; var l = o.l||5; var iy = e.outer/2-e.T.depth; var ix = e.T.width/2-(e.outer/2-iy-e.thickness-e.T.thickness); var rv = CAG.roundedRectangle({ corner1: [-e.outer/2,-e.outer/2], corner2: [e.outer/2,e.outer/2], roundradius: e.roundius }).subtract( FOURWINDS.map(function(w) { return CAG.fromPoints([ [ e.slot_width/2,e.outer/2+1], [ e.slot_width/2,e.outer/2-e.thickness], [ e.T.width/2,e.outer/2-e.thickness], [ e.T.width/2,e.outer/2-e.thickness-e.T.thickness], [ ix, iy ], [ -ix, iy ], [ -e.T.width/2,e.outer/2-e.thickness-e.T.thickness], [ -e.T.width/2,e.outer/2-e.thickness], [ -e.slot_width/2,e.outer/2-e.thickness], [ -e.slot_width/2,e.outer/2+1], ]).rotateZ(w); }) ).subtract(CAG.circle({ center: [0,0], radius: e.centerhole/2 })).extrude({offset:[0,0,l]}); rv.properties.c_top=rv.properties.c_left = new CSG.Connector([0,0,l],[0,0,-1],[1,0,0]); rv.properties.c_bottom=rv.properties.c_right = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); rv.properties.c_midway = new CSG.Connector([0,0,l/2],[0,0,1],[1,0,0]); rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); rv.properties.vitamin = true; return rv; }, cap: function extrusion_cap(o) { if(!o) o = {}; var e = o.extrusion || this; var thickness = o.thickness||2, l = o.l||5; var rv = CSG.roundedCube({ corner1: [-e.outer/2,-e.outer/2,thickness], corner2: [e.outer/2,e.outer/2,0], roundradius: [e.roundius,e.roundius,0] }); var fw = [0,90,180,270]; // four winds var iy = e.outer/2-e.T.depth; var ix = e.T.width/2-(e.outer/2-iy-e.thickness-e.T.thickness); rv = rv.union(fw.map(function(w) { return CAG.fromPoints([ [ e.slot_width/2,e.outer/2], [ e.slot_width/2,e.outer/2-e.thickness], [ e.T.width/2,e.outer/2-e.thickness], [ e.T.width/2,e.outer/2-e.thickness-e.T.thickness], [ ix, iy ], [ -ix, iy ], [ -e.T.width/2,e.outer/2-e.thickness-e.T.thickness], [ -e.T.width/2,e.outer/2-e.thickness], [ -e.slot_width/2,e.outer/2-e.thickness], [ -e.slot_width/2,e.outer/2], ]).extrude({offset:[0,0,l+thickness]}).rotateZ(w); })); rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); return rv; } }; var THREEWINDS = [0,120,240]; function base_extrusions() { var rv = union( THREEWINDS.map(function(w) { var e = E2020.extrusion({l:CONFIG.base.el}); e = e.connectTo(e.properties.c_midway, new CSG.Connector([0,-CD.base.mid_inscription_r,CONFIG.extrusion.w/2],[1,0,0],[0,0,1]), false, 0); return union( [0,CONFIG.extrusion.w+CONFIG.base.gap].map(function(z) { return e.translate([0,0,z]); }) ).rotateZ(w); }) ); rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); return rv.setColor(CONFIG.color.extrusion); } function column_extrusions() { var rv = union( THREEWINDS.map(function(w) { return E2020.extrusion({l:CONFIG.column.h}).translate([0,CD.base.column_r,0]).rotateZ(w); }) ); rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); return rv.setColor(CONFIG.color.extrusion); } +function duet() { + var C = CONFIG.duet; + var pholes = new CSG.Properties(); + var hx = C.hole_spacing.x/2; + var hy = C.hole_spacing.y/2; + var hh = { nw: [1,-1], ne: [1,1], se: [-1,1], sw: [-1,-1] }; + var holes = []; + for(w in hh) { + var h = hh[w],_x=h[0]*hx,_y=h[1]*hy; + holes.push(CSG.cylinder({start:[_x,_y,-1],end:[_x,_y,C.pcb_size.z+1],radius:3/2})); + pholes['c_'+w] = new CSG.Connector([_x,_y,0],[0,0,1],[1,0,0]); + } + rv = CSG.cube({ + corner1: [-C.pcb_size.x/2, -C.pcb_size.y/2, 0], + corner2: [ C.pcb_size.x/2, C.pcb_size.y/2, C.pcb_size.z] + }).subtract(holes).setColor(CONFIG.color.pcb).union( + CSG.cube({ + corner1: [-C.pcb_size.x/2,-C.hole_spacing.y/2+3,C.pcb_size.z], + corner2: [ C.pcb_size.x/2, C.hole_spacing.y/2-3,C.h] + }).setColor(CONFIG.color.bulk) + ); + rv.properties.holes = pholes; + rv.properties.P = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]); + rv.properties.vitamin = true; + return rv; +} + function refaxes(o) { if(!o) o = {}; var l = o.l||20, g = o.g||0.7; return union([ CSG.cylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]), CSG.cylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]), CSG.cylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g]) ]); } function P(x) { return x.connectTo(x.properties.P,new CSG.Connector([0,0,0],[0,0,1],[1,0,0]), false, 0); } function main(params) { return refaxes().union(P(base_extrusions())); } function _main(params) { var e = EFFECTOR.effector(); var hs = E3DV6.heatsink(); hs = hs.connectTo(hs.properties.grove_connector,e.properties.grove_connector,false,0); var ms = microswitch(); var hd = EFFECTOR.hinged({ microswitch:ms,effector:e }); ms = ms.connectTo( ms.properties.screw_connector[0], hd.properties.microswitch_screw_connector[0], false, 0); var hdhd = EFFECTOR.split_hinged(hd); var fh = EFFECTOR.fanholder(); return union({ platform: e, hinged: hdhd[1], clamp: hdhd[0], fanholder: fh, alltogethernow: [e,hdhd[0],hdhd[1], columns(),hs,ms,fh] }[params.part||'alltogethernow']) var rv = union( e, hs, columns(), ///hd, hdhd[0], hdhd[1], ms); return rv; } function getParameterDefinitions() { return [{ name: 'part', type: 'choice', values: [ 'platform', 'hinged', 'clamp', 'fanholder', 'alltogethernow', 'wip' ], captions: [ 'Effector platform', 'Hinged part', 'Clamp', 'Fan holder', 'All together now!', 'Work in progress' ], caption: 'Part', initial: 'wip' }]; } /* vim:set ft=javascript ai: */ |